# This file is the entry point to configure your own services.
# Files in the packages/ subdirectory configure your dependencies.

# Put parameters here that don't need to change on each machine where the app is deployed
# https://symfony.com/doc/current/best_practices/configuration.html#application-related-configuration
parameters:

imports:
    - { resource: 'app/*.yml' }

twig:
    globals:
        user_handler: '@App\Service\UserHandler'

services:
    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.

    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    App\:
        resource: '../src/*'
        exclude: '../src/{DependencyInjection,Entity,Migrations,Tests,Kernel.php}'

    # Set Twig extensions
    App\Twig\Extensions:
      tags: ['twig.extension']

    # Set some services to be public
    App\Service\CitizenHandler:
        public: true
    App\Service\DeathHandler:
        public: true
    App\Service\UserHandler:
        public: true
    App\Service\InventoryHandler:
        public: true
    App\Service\ItemFactory:
        public: true
    App\Service\TownHandler:
        public: true

    # controllers are imported separately to make sure services can be injected
    # as action arguments even if you don't extend any base controller class
    App\Controller\:
        resource: '../src/Controller'
        tags: ['controller.service_arguments']

    # Some classes need the fully featured translator class instead of
    # just the interface, in order to set a locale
    App\Command\SchedulerCommand:
        arguments:
            $translator: '@translator.default'

    # The NightlyHandler should have it's own log channel
    App\Service\NightlyHandler:
        tags:
          - { name: monolog.logger, channel: night }

    App\Command\DebugCommand:
        arguments:
            $translator: '@translator.default'

    App\Command\Town\TownInspectorCommand:
        arguments:
            $translator: '@translator.default'

    App\Command\Town\TownCreateCommand:
        arguments:
            $translator: '@translator.default'

    App\EventSubscriber\DebugSubscriber:
        tags: []
        autoconfigure: false

    # TimeKeeperService should not keep the attack going for 20 minutes after
    # it has finished processing in dev mode, so we need to pass the environment
    App\Service\TimeKeeperService:
        arguments:
            $env: '%kernel.environment%'

    # add more service definitions when explicit configuration is needed
    # please note that last definitions always *replace* previous ones
    App\Translation\DatabaseExtractor:
        tags:
            - { name: translation.extractor, alias: DatabaseExtractor }
    App\Translation\ExpandedPhpExtractor:
        tags:
            - { name: translation.extractor, alias: ExpandedPhpExtractor }

    App\Translation\ExpandedDumper:
        tags:
            - { name: translation.dumper, alias: xlf2 }

    translation.loader.xliff:
        class: App\Translation\ProperXliffFileLoader
        tags:
            - { name: translation.loader, alias: xlf }

    App\Translation\FixtureExtractor:
        tags:
            - { name: translation.extractor, alias: FixtureExtractor }

    App\Service\ConfMaster:
        arguments:
            $global: '%myhordes%'
            $local:  '%local%'
            $rules:  '%rules%'
            $events: '%events%'